Language.Haskell.Exts.Annotated.Syntax

# Modules

data Module l
data ModuleHead l
data WarningText l
data ExportSpecList l
data ExportSpec l
data ImportDecl l
data ImportSpecList l
data ImportSpec l
data Assoc l

# Declarations

data Decl l
data DeclHead l
data InstHead l
data Binds l
data IPBind l

## Type classes and instances

data ClassDecl l
data InstDecl l
data Deriving l

## Data type declarations

data DataOrNew l
data ConDecl l
data FieldDecl l
data QualConDecl l
data GadtDecl l
data BangType l

## Function bindings

data Match l
data Rhs l
data GuardedRhs l

# Class Assertions and Contexts

data Context l
data FunDep l
data Asst l

# Types

data Type l
data Boxed
data Kind l
data TyVarBind l

# Expressions

data Exp l
data Stmt l
data QualStmt l
data FieldUpdate l
data Alt l
data GuardedAlts l
data GuardedAlt l
data XAttr l

# Patterns

data Pat l
data PatField l
data PXAttr l
data RPat l
data RPatOp l

# Literals

data Literal l

# Variables, Constructors and Operators

data ModuleName l
data QName l
data Name l
data QOp l
data Op l
data SpecialCon l
data CName l
data IPName l
data XName l

# Template Haskell

data Bracket l
data Splice l

# FFI

data Safety l
data CallConv l

# Pragmas

data ModulePragma l
data Tool
data Rule l
data RuleVar l
data Activation l
data Annotation l

# Builtin names

## Modules

prelude_mod
main_mod

## Main function of a program

main_name

## Constructors

unit_con_name
tuple_con_name
list_cons_name
unboxed_singleton_con_name
unit_con
tuple_con
unboxed_singleton_con

## Special identifiers

as_name
qualified_name
hiding_name
minus_name
bang_name
dot_name
star_name
export_name
safe_name
unsafe_name
threadsafe_name
stdcall_name
ccall_name

## Type constructors

unit_tycon_name
fun_tycon_name
list_tycon_name
tuple_tycon_name
unboxed_singleton_tycon_name
unit_tycon
fun_tycon
list_tycon
tuple_tycon
unboxed_singleton_tycon

# Source coordinates

# Annotated trees

class Annotated ast
(=~=)